default:
  interruptible: true

stages:
  - build
  - test

variables:
  GIT_SUBMODULE_STRATEGY: recursive
  npm_config_fund: "false"

.test:
  stage: test
  script:
    - npm ci
    - npm run rebuild
    - npm run lint
    - npm test

test:linux:node18:
  extends: .test
  image: node:18-bullseye

test:linux:node20:
  extends: .test
  image: node:20-bullseye

test:windows:
  extends: .test
  before_script:
    - choco install python --pre -y
  tags:
    - saas-windows-medium-amd64 # this has node installed out of the box

# publishes the docs to https://eyeo.gitlab.io/adblockplus/abc/abp2dnr/
pages:
  stage: build
  image: node:18-bullseye
  script:
    - npm ci
    - npm run docs
  artifacts:
    paths:
      - public
  rules:
    # Only publishes docs pushed to main
    - if: $CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH
